/**
 * PSpice-DMI Model File Auto-generated by PSpice Model Editor
 *
 * TYPICALLY MODIFICATION REQUIRED
 *
 * The user model code can be added directly to this file.
 * Alternately, entry points to user model code can be added in this file, while the user code can be written in a separate file.
 */


#include "StdAfx.h"
#include <string>
#include <vector>
#include <map>
#include <utility>


#include "pspEngFunc.h"
#include "pspNoiseFilter.h"

extern "C" {
#include "../../averaging_filter/averaging_filter.h"
}

#define PSPFUNCTRACE() printf("(%d)%s\n",__LINE__,__FUNCTION__);
/**
 * Primary function used for device loading. This function is called multiple times for 
 * operating point analysis, as well as for each simulation time step in transient analysis.
 */
int pspNoiseFilterDevice::Load(int pMode, int pInitFlag, int pLoadFlag, double tnow) {
	PSPFUNCTRACE();
	int returnVal = 0;
    bool nonConv = false;
	int lStateIndex = fp_getStateIndex();
	sv.adjustState(lStateIndex);

	
	double TIME = fp_getAnalogTime();
	double STEP = fp_getDelta();
	//double xVal = fp_getV(OutPort1,OutPort2); Modify this statement for generic devices
	double xVal = fp_getV( Input1 , Input2 );
	double delta = fp_getDelta();
	double yVal = 0.0;
	double gain = 0.0;

// User Code
	if (pMode != MDTRAN) {
		for (int i = 0; i < 16 + MSTVCT; i++) {
			sv.x[i] = xVal;
		}	
	}
	sv.y[0] = yVal = averaging_filter(xVal, sv.x);
 //


	fp_applyValueItem(ribr,yVal );
	fp_applyValueItem(Output1_cibr,1);
	fp_applyValueItem (Output2_cibr, -1);
	fp_applyValueItem (cibr_Output1, 1 );
	fp_applyValueItem (cibr_Output2, -1 );

  
	return returnVal;
}

/**
 * Function used for checking/updating model parameter values. 
 */
int pspNoiseFilter::ModChk(){
 

	PSPFUNCTRACE();
	return 0;
}


/**
 * Device constructor, also used for initializing parameter values. 
 */
pspNoiseFilterDevice::pspNoiseFilterDevice() {
	PSPFUNCTRACE();
	//initialize internal node names
	cibr = NULL;
	// 
    //For defining a parameter, declare it in pspDeviceTemplate.h class definition, and initialize it here
	//e.g. mGain = 1.0;
}

/**
 * Matrix Stencil creation function, this will be auto-generated for pre-defined device types.
 * Needs to be written by the user for generic device types
 */
void pspNoiseFilterDevice::createMatrixStencil() {
	PSPFUNCTRACE();
	fp_getMatrixPtr(&(ribr), cibr,0);
	fp_getMatrixPtr(&(Output1_cibr), Output1,cibr);
	fp_getMatrixPtr (&(Output2_cibr), Output2,cibr);
	fp_getMatrixPtr (&(cibr_Output1),cibr, Output1);
	fp_getMatrixPtr (&(cibr_Output2),cibr, Output2);
}

/**
 * This function is called for each frequency value during ac sweep.
 */
void pspNoiseFilterDevice::ACLoad(double Omega) {
	PSPFUNCTRACE();
}

/**
 * This function returns max time step supported by device.
 * This can be fixed or calculated dynamically based on integration error.
 */
double pspNoiseFilterDevice::Trunc() {
	PSPFUNCTRACE();
	//return  ; //set to MAXREAL if device does not use TRUNC
	return 1e+30;

}

/**
 * This function is called to update device parameters after temperature changes.
 */
void pspNoiseFilterDevice::TmpMod(double ToldK, double TnewK, double TnomK) {
	PSPFUNCTRACE();
}

