/**
* Copyright by Cadence Design Systems 2015. All rights reserved
*/


#ifndef __pspEngFunc_h_
#define __pspEngFunc_h_
#include "PSpiceBase.h"
#include "PSpiceCMIApiDefs.h"
#include "PSpiceDigApiDefs.h"

typedef int(*pPSpiceGetNodeNumber_t)(const char*);
typedef void(*pPSpiceSetSimulationTemperature_t)(double);

//callback methods
extern descSetInstallFunction_t fp_descSetInstallFunction;
extern pPSpiceSetSimulationTemperature_t fp_setSimTemp;
extern pPSpiceSetProbeTitle_t fp_descSetProbeTitle;
extern pPSpiceGetCurrentAnalogTime_t fp_getAnalogTime;
extern pPSpiceGetCurrentDigitalTime_t fp_getDigitalTime; //Digital
extern pPSpiceGetParamValue_t fp_GetParamValue;
extern pPSpiceGetParamValueDbl_t fp_GetParamValueDbl;
extern pPSpiceSetDelay_t fp_setDelay;					//Digital
extern pPSpiceSetConstraint_t fp_setConstraint;			//Digital
extern pPSpiceSetInputSpec_t fp_setInputSpec;			//Digital
extern pPSpiceSetOutputSpec_t fp_setOutputSpec;			//Digital
extern pPSpiceGetInputSpec_t fp_getInputSpec;			//Digital
extern pPSpiceGetOutputSpec_t fp_getOutputSpec;			//Digital
extern pPSpiceGetTimingModelValue_t fp_getTimingValue;	//Digital
extern pPSpiceAddInternalNode_t fp_addInternalNode1;			 
extern pPSpiceAddInternalNodeByName_t fp_addInternalNode;

extern pPSpiceGetMatrixPtr_t fp_getMatrixPtr;
extern pPSpiceGetRHSPtr_t fp_getRHSPtr;
extern pPSpiceApplyValueItem_t fp_applyValueItem;
extern pPSpiceApplyValueItemComplex_t fp_applyValueItemComplex;
extern pPSpiceGetVoltageNodes_t fp_getV;
extern pPSpiceGetVoltageNodesI_t fp_getVoltageI;
extern pPSpiceGetDelta_t fp_getDelta;
extern pPSpiceGetDeltaPrevious_t fp_getDeltaPrevious;
extern pPSpiceVoltageTolerance_t fp_VoltageTOL;
extern pPSpiceVoltageTolerance_t fp_CurrentTOL;
extern pPSpiceIntegrate_t fp_Integrate;
extern pPSpiceGetCurrentStateIndex_t fp_getStateIndex;
//PSPICE_GMINLOAD
extern pPSpiceGetFrequency_t fp_getFrequency;
extern descSetInstDataStructSize_t fp_descSetInstDataStructSize;
extern descSetModelDataStructSize_t fp_descSetModelDataStructSize;
extern descSetSignalsStructSize_t fp_descSetSignalsStructSize;
extern descSetStateStructSize_t fp_descSetStateStructSize;
extern descSetReserveNodes_t fp_descSetReserveNodes;
extern descSetAddInternalNodes_t fp_descSetAddInternalNodes;
extern descSetGetMatrixPointers_t fp_descSetGetMatrixPointers;
extern descSetBindTerminals_t fp_descSetBindTerminals;
extern descSetDefaultState_t fp_descSetDefaultState;
//PSPICE_SET_MODELPARAMDESC
extern descSetStencilStructSize_t fp_descSetStencilStructSize;
extern descSetPreload_t fp_descSetPreload;
extern descSetTranLoad_t fp_descSetTranLoad;
extern descSetAC_Load_t fp_descSetACLoad;
extern descSetTrunc_t fp_descSetTrunc;
extern descSetNoise_t fp_descSetNoise;
extern pGetBreakPoint_t fp_GetBreakPoint;
extern descSetTmpModModel_t fp_descSetTmpModModel;
extern descSetTmpModDevice_t fp_descSetTmpModDevice;
extern descSetDefaultModel_t fp_descSetDefaultModel;
extern descSetSetModelParams_t fp_descSetSetModelParams;
extern descSetCheckModel_t fp_descSetModChk;
extern descSetDefaultInstance_t fp_descSetDefaultInstance;
extern descSetSetInstanceParams_t fp_descSetSetInstanceParams;
extern descSetVersion_t fp_descSetVersion;
extern descSetName_t fp_descSetName;
extern pPSpiceUpdateStateVector_t fp_UpdateSV;
extern pPSpiceCurrentTErr_t fp_currentTerr;
extern pPrintDescription_t fp_printDescription;
extern descSetSaveCheckpoint_t fp_descSetSaveCheckpoint;
extern descSetLoadCheckpoint_t fp_descSetLoadCheckpoint;
extern descSetSaveTopology_t fp_descSetSaveTopology;
extern descSetCheckTopology_t fp_descSetCheckTopology;
extern descSetDeleteInstance_t fp_descSetDeleteInstance;
extern descSetDeleteModel_t fp_descSetDeleteModel;
extern descSetSetDevicePinCurrent_t fp_descSetSetDevicePinCurrent;
extern descSetSetDevicePinCurrentComplex_t fp_descSetSetDevicePinCurrentComplex;

extern descSetCreateDevice_t fp_descSetCreateDevice;
extern descSetDeleteDevice_t fp_descSetDeleteDevice;
extern descSetGetDeviceTermCount_t fp_descSetGetDeviceTermCount;
extern descSetSetDeviceTermCount_t fp_descSetSetDeviceTermCount;
extern descSetEvaluateDevice_t fp_descSetEvaluateDevice;
extern descSetSetDeviceTermValue_t fp_descSetSetDeviceTermValue;
extern descSetGetDeviceTermValue_t fp_descSetGetDeviceTermValue;
extern descSetGetDeviceTerminals_t fp_descSetGetDeviceTerminals;
extern descSetSetParameter_t fp_descSetSetParameter;
extern pDigPrintDescription_t fp_descSetDigPrintDescription;
extern pPSpiceWriteToOut_t fp_PSpiceWriteToOut;
extern pPSpiceChanged_t fp_PSpiceChanged;
extern pPSpiceGetTransition_t fp_GetTransition;
extern descSetInitDevice_t fp_descSetInitDevice;
extern pPSpiceSetState_t fp_SetState;
extern pPSpiceGetParameterValue_t fp_GetParameterValue;
extern pGetTimeFromTicks_t fp_getTimeFromTicks;
extern pGetTicksFromTime_t fp_getTicksFromTime;

extern descSetSetTopologySize_t fp_descSetTopologySize;
extern descSetCheckPointSize_t fp_descSetCheckpointSize;
extern pPSpiceGetLicenseString_t fp_getLicenseString;
extern pPSPICEGetOptionsParams_t fp_getOptionParams;
extern pPSpiceAdjustValueItem_t fp_adjustValueItem;

extern char* getModeStr(modeFlags Mode);
extern char* getInitFlagsStr(initFlags flag);

//DIG

extern pGetBreakPoint_t fp_GetBreakPoint;
extern descSetVersion_t fp_descSetVersion;
extern pPrintDescription_t fp_printDescription;
extern descSetSetDeviceTermCount_t fp_descSetSetDeviceTermCount;
extern descSetSetDeviceTermValue_t fp_descSetSetDeviceTermValue;
extern pDigPrintDescription_t fp_descSetDigPrintDescription;
extern pPSpiceWriteToOut_t fp_PSpiceWriteToOut;
extern pPSpiceChanged_t fp_PSpiceChanged;
inline double VMAG(const char* node1, const char* node2)
{
    return SUM_SQR(fp_getV(node1, node2), fp_getVoltageI(node1, node2));
}

inline char* pspUpperCase(char* pStr) {
	size_t len = strlen(pStr);
	for(unsigned int i=0; i<len; i++) {
		pStr[i] = (char)(toupper(pStr[i]));
	}
	return pStr;
}
					 

#define pspBits2Int(lpspBit,lint, lBitCount) {\
lint = 0; \
for (unsigned int i = lBitCount; i > 0; i--) {\
	lint <<= 1; \
	lint |= (int)lpspBit[i-1]; \
}\
}

#define Int2pspBits(lint, lpspBit, lBitCount)  {\
unsigned long long value = lint; \
for (unsigned int i = 0; i < lBitCount ; i++) {\
	lpspBit[i] = value&0x01; \
	value >>= 1; \
	}\
}

#define pspBits2Array(lpspBit,lint, lBitCount)  \
{\
for (int i = 0; i < lBitCount; i++) {\
	lint[i] = (int)lpspBit[i] == 1 ? 1 : 0; \
}\
}

#define Array2pspBits(lint, lpspBit, lBitCount)  \
{\
for (int i = 0; i < lBitCount; i++) {\
	lpspBit[i] = lint[i]; \
}\
}


#define sc_logic2value(signal, value)\
if (signal == SC_LOGIC_0)\
	value = 0; \
	else if (signal == SC_LOGIC_1)\
	value = 1; \
	else if (signal == SC_LOGIC_Z)\
	value = 3;

#define value2sc_logic(signal, value)\
	signal = SC_LOGIC_X; \
if (value == 0)\
	signal = SC_LOGIC_0; \
	else if (value == 1)\
	signal = SC_LOGIC_1; \
	else if (value == -3)\
	signal = SC_LOGIC_Z;

extern descSetVersion_t fp_descSetCMIVersion;

#endif
