/**
 * PSpice-DMI Model File Auto-generated by PSpice Model Editor
 *
 * TYPICALLY MODIFICATION REQUIRED
 *
 * The user model code can be added directly to this file.
 * Alternately, entry points to user model code can be added in this file, while the user code can be written in a separate file.
 */


#include "StdAfx.h"
#include <string>
#include <vector>
#include <map>
#include <utility>

#include "pspEngFunc.h"
#include "pspArduinoHILDemo1.h"
#include "CSerial.h"

#define PSPFUNCTRACE() printf("(%d)%s\n",__LINE__,__FUNCTION__);
/**
 * Primary function used for device loading. This function is called multiple times for 
 * operating point analysis, as well as for each simulation time step in transient analysis.
 */
int pspArduinoHILDemo1Device::Load(int pMode, int pInitFlag, int pLoadFlag, double tnow) {
	PSPFUNCTRACE();
	fprintf(stderr, "In load\n");
	double multiplier = 5.0 / 1024.0;
	int returnVal = 0;
    bool nonConv = false;

	double vin = (fp_getV(Input1, Input2) + MINREAL) * 10;
	
	double TIME = fp_getAnalogTime();
	double STEP = fp_getDelta();
	fprintf(stderr, "TIME=%g DELTA=%g vin=%g \n", TIME, STEP, vin);
	//double xVal = fp_getV(OutPort1,OutPort2); Modify this statement for generic devices
	double gain = 0.0;

	if (pInitFlag == ININIT) {
		serialInterface.Open(4);
		serialInterface.ReadDataWaiting();
		prevTIME = -1;
	}

	if (pMode == MDTRAN && prevTIME != TIME && pInitFlag != INPRDCT) {
		sprintf(commBuffer, "%d\n", (int)vin);
		int bytesWritten = serialInterface.SendData(commBuffer, strlen(commBuffer));
		fprintf(stderr, "bytesWritten=%d vin=%.*s\n", bytesWritten, strlen(commBuffer), commBuffer);
		int bytesRead = 0;
		for (int i = 0; i < 3; i++) {
			for (;;) {
				char ch = '|';
				int bytesReadTemp = serialInterface.ReadData(&ch, 1);
				if (bytesReadTemp == 0)
					continue;
				if (ch == '\n'){
					if (bytesRead < 2)
						continue;
					break;
				}

				commBuffer[bytesRead] = ch;
				bytesRead += bytesReadTemp;
			}
			commBuffer[bytesRead] = 0;
			switch (i) {
			case 0:
			{
				vout = atoi(commBuffer) * multiplier * 2;
				gain = vout / vin;
				bytesRead = 0;
				break;
			};
			case 1:
			{
				vtemp = ((atof(commBuffer) / 1024.0*5.0) - 0.5) * 100;
				bytesRead = 0;
				break;
			};
			case 2:
			{
				vtilt = atoi(commBuffer);
				bytesRead = 0;
				break;
			}
			}
		}
		fprintf(stderr, "bytesRead=%d  gain=%g vout=%g vtemp=%g vtilt=%g\n", bytesRead, gain, vout, vtemp, vtilt);
		prevTIME = TIME;
	}
 

	fp_applyValueItem(cibr_Input1, -gain);
	fp_applyValueItem(cibr_Input2, gain);
	fp_applyValueItem(Output1_cibr, 1.);
	fp_applyValueItem(Output2_cibr, -1.);
	fp_applyValueItem(cibr_Output1, 1.);
	fp_applyValueItem(cibr_Output2, -1.);
	fp_applyValueItem(ribr, vout);

	fp_applyValueItem(cibr_tempNode, 1.);
	fp_applyValueItem(tempNode_cibr, 1.);
	fp_applyValueItem(rhsTemp, vtemp);

	fp_applyValueItem(cibr_tiltNode, 1.);
	fp_applyValueItem(tiltNode_cibr, 1.);
	fp_applyValueItem(rhsTilt, vtilt);


  
	return returnVal;
}

/**
 * Function used for checking/updating model parameter values. 
 */
int pspArduinoHILDemo1::ModChk(){
 

	PSPFUNCTRACE();
	return 0;
}


/**
 * Device constructor, also used for initializing parameter values. 
 */
pspArduinoHILDemo1Device::pspArduinoHILDemo1Device() {
	PSPFUNCTRACE();
	//initialize internal node names
	cibr = NULL;
	// 
    //For defining a parameter, declare it in pspDeviceTemplate.h class definition, and initialize it here
	//e.g. mGain = 1.0;
}

/**
 * Matrix Stencil creation function, this will be auto-generated for pre-defined device types.
 * Needs to be written by the user for generic device types
 */
void pspArduinoHILDemo1Device::createMatrixStencil() {
	PSPFUNCTRACE();
	fp_getMatrixPtr(&(ribr), cibr, 0);
	fp_getMatrixPtr(&(Output1_cibr), Output1, cibr);
	fp_getMatrixPtr(&(Output2_cibr), Output2, cibr);
	fp_getMatrixPtr(&(cibr_Output1), cibr, Output1);
	fp_getMatrixPtr(&(cibr_Output2), cibr, Output2);
	fp_getMatrixPtr(&(cibr_Input1), cibr, Input1);
	fp_getMatrixPtr(&(cibr_Input2), cibr, Input2);

	fp_getMatrixPtr(&(rhsTemp), cibr_temp, 0);
	fp_getMatrixPtr(&(cibr_tempNode), tempNode, cibr_temp);
	fp_getMatrixPtr(&(tempNode_cibr), cibr_temp, tempNode);

	fp_getMatrixPtr(&(rhsTilt), cibr_tilt, 0);
	fp_getMatrixPtr(&(cibr_tiltNode), tiltNode, cibr_tilt);
	fp_getMatrixPtr(&(tiltNode_cibr), cibr_tilt, tiltNode);

}

/**
 * This function is called for each frequency value during ac sweep.
 */
void pspArduinoHILDemo1Device::ACLoad(double Omega) {
	PSPFUNCTRACE();
}

/**
 * This function returns max time step supported by device.
 * This can be fixed or calculated dynamically based on integration error.
 */
double pspArduinoHILDemo1Device::Trunc() {
	PSPFUNCTRACE();
	//return  ; //set to MAXREAL if device does not use TRUNC
	return 1e+30;

}

/**
 * This function is called to update device parameters after temperature changes.
 */
void pspArduinoHILDemo1Device::TmpMod(double ToldK, double TnewK, double TnomK) {
	PSPFUNCTRACE();
}

