/*
 * averaging_filter.c
 *
 * Code generation for function 'averaging_filter'
 *
 */
// SALONI NOT TO BE GENERATED
/* Include files */
#include "rt_nonfinite.h"
#include "averaging_filter.h"

/* Function Definitions */
double averaging_filter(const double x,  double* buffer)
{
	double y;
  double dv0[15];
  double b_y;
  int k;

	/*  y = averaging_filter(x) */
	/*  Take an input vector signal 'x' and produce an output vector signal 'y' with */
	/*  same type and shape as 'x' but filtered. */
	/*  Use a persistent variable 'buffer' that represents a sliding window of */
	/*  16 samples at a time. */
	/*  Scroll the buffer */
	memcpy(&dv0[0], &buffer[0], 15U * sizeof(double));
	memcpy(&buffer[1], &dv0[0], 15U * sizeof(double));

	/*  Add a new sample value to the buffer */
	buffer[0] = x;

	/*  Compute the current average value of the window and */
	/*  write result */
	b_y = buffer[0];
	for (k = 0; k < 15; k++) {
	b_y += buffer[k + 1];
	}
	y = b_y / 16.0;
	return y;
}

void averaging_filter_init(double* buffer)
{
  memset(&buffer[0], 0, sizeof(double) << 4);
}

/* End of code generation (averaging_filter.c) */
