/***
*** Interface: pspice 16.6
 *** created by: admsXml-2.3.0 - Mon, 25 Jul 2016 14:36:59 ***/
#ifndef cap
#define cap
#include "PSpiceBase.h"

#ifdef c1
  #warning conflict: c1 is declared as a variable of module 'cap'.
  #warning conflict: However in the API of pspice 'c1' is also defined as a pragma.
  #warning conflict: Pragma 'c1' will be undefined.
  #warning conflict: You can solve the confict by renaming variable 'c1' in module 'cap'.
  #undef c1
#endif
#ifdef c2
  #warning conflict: c2 is declared as a variable of module 'cap'.
  #warning conflict: However in the API of pspice 'c2' is also defined as a pragma.
  #warning conflict: Pragma 'c2' will be undefined.
  #warning conflict: You can solve the confict by renaming variable 'c2' in module 'cap'.
  #undef c2
#endif
#ifdef c2
  #warning conflict: GND is declared as a node of module 'cap'.
  #warning conflict: However in the API of pspice 'GND' is also defined as a pragma.
  #warning conflict: Pragma 'GND' will be undefined.
  #warning conflict: You can solve the confict by renaming variable 'GND' in module 'cap'.
  #undef c2
#endif
#ifdef c2
  #warning conflict: p is declared as a node of module 'cap'.
  #warning conflict: However in the API of pspice 'p' is also defined as a pragma.
  #warning conflict: Pragma 'p' will be undefined.
  #warning conflict: You can solve the confict by renaming variable 'p' in module 'cap'.
  #undef c2
#endif
#ifdef c2
  #warning conflict: n is declared as a node of module 'cap'.
  #warning conflict: However in the API of pspice 'n' is also defined as a pragma.
  #warning conflict: Pragma 'n' will be undefined.
  #warning conflict: You can solve the confict by renaming variable 'n' in module 'cap'.
  #undef c2
#endif

#ifdef PSPICE_DEBUG_OK
#define PSPICE_DEBUG \
{ \
  if(getenv("pspice_debug")) \
  debug(pInfo); \
  else \
  { \
  printf("  To get more info run your simulation after setting shell variable pspice_debug to 1\n"); \
    printf("  For example in sh shell just type: export pspice_debug=1\n"); \
  } \
  }
  #else
  #define PSPICE_DEBUG
  #endif

  #define EXIT_IF_ISNAN(var) \
  if(_isnan((double) var)) \
  { \
  printf("%s:%i:bug:isnan:"#var"\n",__FILE__,__LINE__); \
  PSPICE_DEBUG \
  exit(1); /*__asm__ __volatile__ ("int $03");*/ \
  } \
  if(_isnan((double) var)) \
  { \
  printf("%s:%i:bug:isinf:"#var"\n",__FILE__,__LINE__); \
  PSPICE_DEBUG \
  exit(1); /*__asm__ __volatile__ ("int $03");*/ \
}

/* pspice $simparam variables
    gdev                (1/Ohms): Additional conductance to be added to nonlinear branches for conductance homotopy convergence algorithm.
    gmin                (1/Ohms): Minimum conductance placed in parallel with nonlinear branches.
    imax                (Amps)  : Branch current threshold above which the constitutive relation of a nonlinear branch should be linearized.
    imelt               (Amps)  : Branch current threshold indicating device failure.
    iteration                   : Iteration number of the analog solver.
    scale                       : Scale factor for device instance geometry parameters.
    shrink                      : Optical linear shrink factor.
    simulatorSubversion         : The simulator sub-version.
    simulatorVersion            : The simulator version.
    sourceScaleFactor           : Multiplicative factor for independent sources for source stepping homotopy convergence algorithm.
    tnom degrees       (Celsius): Default value of temperature at which model parameters were extracted.
*/

#define _circuit_gdev                pInfo->CKTgmin
#define _circuit_gmin                ((pInfo->CKTgmin)>(pInfo->CKTdiagGmin))?(pInfo->CKTgmin):(pInfo->CKTdiagGmin)
  #define _circuit_imax                1.0
  #define _circuit_imelt               1.0
  #define _circuit_iteration           1.0
  #define _circuit_scale               1.0
  #define _circuit_shrink              1.0
  #define _circuit_simulatorSubversion 0
  #define _circuit_simulatorVersion    3.5
  #define _circuit_sourceScaleFactor   1.0
  #define _circuit_tnom                pInfo->CKTnomTemp

  #define _circuit_temp      pInfo->Temperature
#define _scale             1.0

#define _cos(val,arg)            val = cos(arg);
#define _d_cos(val,dval,arg)     val = cos(arg);     dval = (-sin(arg));
#define _sin(val,arg)            val = sin(arg);
#define _d_sin(val,dval,arg)     val = sin(arg);     dval = (cos(arg));
#define _tan(val,arg)            val = tan(arg);
#define _d_tan(val,dval,arg)     val = tan(arg);     dval = (1.0/cos(arg)/cos(arg));
#define _hypot(xy,x,y)           xy = sqrt((x)*(x)+(y)*(y));
#define _dx_hypot(dx,xy,x,y)     dx = (x)/(xy);
#define _dy_hypot(dy,xy,x,y)     dy = (y)/(xy);
#define _max(xy,x,y)             xy = ((x)>(y))?(x):(y);
#define _dx_max(dx,xy,x,y)       dx = ((x)>(y))?1.0:0.0;
#define _dy_max(dy,xy,x,y)       dy = ((x)>(y))?0.0:1.0;
#define _min(xy,x,y)             xy = ((x)<(y))?(x):(y);
#define _dx_min(dx,xy,x,y)       dx = ((x)<(y))?1.0:0.0;
#define _dy_min(dy,xy,x,y)       dy = ((x)<(y))?0.0:1.0;
#define _cosh(val,arg)           val = cosh(arg);
#define _d_cosh(val,dval,arg)    val = cosh(arg);    dval = (sinh(arg));
#define _sinh(val,arg)           val = sinh(arg);
#define _d_sinh(val,dval,arg)    val = sinh(arg);    dval = (cosh(arg));
#define _tanh(val,arg)           val = tanh(arg);
#define _d_tanh(val,dval,arg)    val = tanh(arg);    dval = (1.0/cosh(arg)/cosh(arg));
#define _acos(val,arg)           val = acos(arg);
#define _d_acos(val,dval,arg)    val = acos(arg);    dval = (-1.0/sqrt(1-arg*arg));
#define _asin(val,arg)           val = asin(arg);
#define _d_asin(val,dval,arg)    val = asin(arg);    dval = (+1.0/sqrt(1-arg*arg));
#define _atan(val,arg)           val = atan(arg);
#define _d_atan(val,dval,arg)    val = atan(arg);    dval = (+1.0/(1+arg*arg));
#define _logE(val,arg)           val = log(arg);
#define _d_logE(val,dval,arg)    val = log(arg);     dval = (1.0/arg);
#define _log10(val,arg)          val = log10(arg);
#define _d_log10(val,dval,arg)   val = log10(arg);   dval = (1.0/arg/log(10));
#define _exp(val,arg)            val = exp(arg);
#define _d_exp(val,dval,arg)     val = exp(arg);     dval = val;
#define _sqrt(val,arg)           val = sqrt(arg);
#define _d_sqrt(val,dval,arg)    val = sqrt(arg);    dval = (1.0/val/2.0);
#define _pow(xy,x,y)             xy = pow(x,y);
#define _dx_pow(dx,xy,x,y)       dx = (x==0.0)?0.0:((y/x)*xy);
#define _dy_pow(dy,xy,x,y)       dy = (x==0.0)?0.0:((log(x)/exp(0.0))*xy);

#define _div1(x,y)               ((x)/(y))
#define _div0(xy,x,y)            xy=(x)/(y);
#define _div(xy,dx,x,y)          dx=1/(y); xy=(x)*dx;
#define _dx_div(dx,xy,x,y)
#define _dy_div(dy,dx,xy,x,y)    dy = -xy*dx;

#define _limexp(val,arg)         val = ((arg)<(90)) ? (exp(arg)) : (exp(90)*(1.0+(arg-90)));
#define _d_limexp(val,dval,arg)  val = ((arg)<(90)) ? (exp(arg)) : (exp(90)*(1.0+(arg-90))); dval = val;
#define _fabs(val,arg)           val = fabs(arg);
#define _d_fabs(val,dval,arg)    val = fabs(arg);    dval = (((val)>=0)?(+1.0):(-1.0));
#define _abs(val)                ((val)<(0) ? (-(val)):(val))

/* declarations for cap MOSFETs */

/* information needed for each instance */

class capinstance : public PSpiceDevice {
public:
  class capmodel *capmodPtr;           /* pointer to model */
  std::string capname; /* pointer to character string naming this instance */

  /* Internal nodes - a maximum of 100 are supported */
  double* intNodes[100];
  
  /* node numbers */
  int pNode;
  int nNode;


/* node names */
  char pNodeStr[1024];
  char nNodeStr[1024];


  /* instance parameters */

 // noise


  /* variables */

  /* states (these numbers are offsets to state data structure */
  int state_p_n;



  double* states0;
  double* states1;
  
  /* pointer to sparse matrix (+ values)*/  double *PTR_J_p_p;
    int PTR_J_p_p_required;
    double JDVAL_p_p;
  double *PTR_J_p_n;
    int PTR_J_p_n_required;
    double JDVAL_p_n;
  double *PTR_J_n_p;
    int PTR_J_n_p_required;
    double JDVAL_n_p;
  double *PTR_J_n_n;
    int PTR_J_n_n_required;
    double JDVAL_n_n;
  virtual void setNodeName(int i, const char* lName);
  virtual bool init();
  virtual void createMatrixStencil ();
  virtual void AddIMatrix();
  virtual int AddInternalNodes(PSpiceDeviceMiscInfo* pMiscInfo);
  virtual void initMatrix();
  virtual int guesstopology (PSpiceDeviceMiscInfo* pInfo, capmodel *model);
  virtual int Load(PSpiceDeviceMiscInfo* pInfo, int CKTmode);
  virtual int ACLoad(double pFreq);
  virtual double Trunc();
  virtual double noise(
     double tnow,		// present device temperature
     double Freq,		// frequency (Hz)
     double* ncmps,		// noise components...
     int pCompsLength);
  void debug (PSpiceDeviceMiscInfo* pInfo);
};
// capinstance ;

  /* per model data */
  class capmodel : public PSpiceModel {
  public:
  int capmodType;        /* type index of this device type */
  /* model parameters */
  double c1;
  unsigned c1_Given  :1;
  double c2;
  unsigned c2_Given  :1;
  /* variable */
  virtual void setParamValue(const char* pName, double pValue);
  virtual bool init();
	virtual int ModChk();
};
// capmodel;
  /* flags */
typedef enum {
  cap_model_c1,
  cap_model_c2,
  DUMMY_MODEL
} e_cap_model;
typedef enum {
  DUMMY_INSTANCE
} e_cap_instance;
#endif /*cap*/
