/***
*** Interface: pspice 16.6
 *** created by: admsXml-2.3.0 - Mon, 25 Jul 2016 14:37:00 ***/
#define PSPICE_DEBUG_OK
#include "StdAfx.h"
#include "pspEngFunc.h"
#include "capdefs.h"
extern pPSpiceAdjustValueItem_t fp_adjustValueItem;
int psIntegrate(capinstance* pDev, double* geq,double* ceq, double cap_val, int state0);
#define NP(p) fp_getV(p ## NodeStr, 0)
#define BP(p,n) (NP(p)-NP(n))
#define DBGNODE(p) printf(#p "=%i - v=%e\n",p ## Node,NP(p));
void setModelPtr(PSpiceDevice* pInst, PSpiceModel* pModel) {
	capinstance* lInst = (capinstance*)pInst;
	lInst->capmodPtr = (capmodel*)pModel;
}
void capinstance::debug (PSpiceDeviceMiscInfo* pInfo)
{
capinstance* here = this;
capmodel* model = capmodPtr;
FILE* logFile = fopen("c:\\temp\\capLog.txt", "w");
  fprintf(logFile,"voltage: p=%e\n",NP(p));
  fprintf(logFile,"voltage: n=%e\n",NP(n));
  fprintf(logFile,"Parameter: model: c1=%e\n",model->c1);
  fprintf(logFile,"Parameter: model: c2=%e\n",model->c2);

  fclose(logFile);
  }
  #define _STATIC
  #define _DYNAMIC
  #define _DERIVATE
  void adjustCurrentItem(PSpiceDevice* pDev,  int pNode, double v);
  double getCurrentItem(PSpiceDevice* pDev,  int pNode);
  #define _load_static_residual2(p,n,v)\
  adjustCurrentItem(this, p ## Node, -1 * v);\
  adjustCurrentItem(this, n ## Node, v);
  #define _load_static_residual1(p,v)\
  adjustCurrentItem(this, p ## Node, -1 * v);
  #define _load_static_jacobian4(Sp,Sn,Pp,Pn,v)\
  _load_static_residual2(Sp,Sn,-v*BP(Pp,Pn))\
  fp_adjustValueItem(PTR_J_ ## Sp ## _ ## Pp, v);\
  fp_adjustValueItem(PTR_J_ ## Sn ## _ ## Pn, v);\
  fp_adjustValueItem(PTR_J_ ## Sp ## _ ## Pn, -1 * v);\
  fp_adjustValueItem(PTR_J_ ## Sn ## _ ## Pp, -1 * v);\
  (JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (JSVAL_ ## Sn ## _ ## Pn)+=v;\
  (JSVAL_ ## Sp ## _ ## Pn)-=v;\
  (JSVAL_ ## Sn ## _ ## Pp)-=v;
  #define _load_static_jacobian2s(Sp,Sn,Pp,v)\
  _load_static_residual2(Sp,Sn,-v*NP(Pp))\
  fp_adjustValueItem(PTR_J_ ## Sp ## _ ## Pp, v);\
  fp_adjustValueItem(PTR_J_ ## Sn ## _ ## Pp, -1 * v);\
  (JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (JSVAL_ ## Sn ## _ ## Pp)-=v;
  #define _load_static_jacobian2p(Sp,Pp,Pn,v)\
  _load_static_residual1(Sp,-v*BP(Pp,Pn))\
  fp_adjustValueItem(PTR_J_ ## Sp ## _ ## Pp, v);\
  fp_adjustValueItem(PTR_J_ ## Sp ## _ ## Pn, -1 * v);\
  (JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (JSVAL_ ## Sp ## _ ## Pn)-=v;
  #define _load_static_jacobian1(Sp,Pp,v)\
  _load_static_residual1(Sp,-1 * v*NP(Pp))\
  fp_adjustValueItem(PTR_J_ ## Sp ## _ ## Pp, v);\
  (JSVAL_ ## Sp ## _ ## Pp)+=v;


  #define _load_dynamic_residual2(p,n,v)\
  if(ChargeComputationNeeded)\
  {\
  int error = false;\
  double unused;\
  *(states0+state_##p##_##n)=v;\
  if(CKTmode & MDBPTR)\
  *(states1 + state_##p##_##n) =*(states0 + state_##p##_##n);\
  psIntegrate(this, &unused,&unused,0.0,state_##p##_##n);\
  if(error) return(error);\
  if(CKTmode & MDBPTR)\
    *(states1+state_##p##_##n+1) = *(states0+state_##p##_##n+1);\
  adjustCurrentItem(this, p##Node, -1 * *(states0+state_##p##_##n+1));\
  adjustCurrentItem(this, n##Node, *(states0+state_##p##_##n+1));\
}

  
#define _load_dynamic_residual1(p,v)\
if(ChargeComputationNeeded)\
{\
  int error = false;\
  double unused;\
  *(states0+state_##p##_GND)=v;\
  if(CKTmode & MDBPTR)\
    *(states1+state_##p##_GND)=*(states0+state_##p##_GND);\
  error = psIntegrate(this,&unused,&unused,0.0,state_##p##_GND);\
  if(error) return(error);\
  if(CKTmode & MDBPTR)\
    *(states1+state_##p##_GND+1) = *(states0+state_##p##_GND+1);\
  adjustCurrentItem(this, p##Node, -1 * *(states0 + state_##p##_GND+1));\
}

#define _load_dynamic_jacobian4(Sp,Sn,Pp,Pn,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*pInfo->CKTag[0];\
  double ceq=geq*BP(Pp,Pn);\
  adjustCurrentItem(this, Sp##Node, ceq);\
  adjustCurrentItem(this, Sn##Node, -1 * ceq);\
  fp_adjustValueItem(PTR_J_ ## Sp ## _ ## Pp, geq);\
  fp_adjustValueItem(PTR_J_ ## Sn ## _ ## Pn, geq);\
  fp_adjustValueItem(PTR_J_ ## Sp ## _ ## Pn, -1 * geq);\
  fp_adjustValueItem(PTR_J_ ## Sn ## _ ## Pp, -1 * geq);\
  }\
  (JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (JDVAL_ ## Sn ## _ ## Pn)+=v;\
  (JDVAL_ ## Sp ## _ ## Pn)-=v;\
  (JDVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_dynamic_jacobian2s(Sp,Sn,Pp,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*pInfo->CKTag[0];\
  double ceq=geq*NP(Pp);\
  adjustCurrentItem(this, Sp##Node, ceq);\
  adjustCurrentItem(this, Sn##Node, -1 * ceq);\
  *(PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(PTR_J_ ## Sn ## _ ## Pp)-=geq;\
}\
  (JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (JDVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_dynamic_jacobian2p(Sp,Pp,Pn,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*pInfo->CKTag[0];\
  double ceq=geq*BP(Pp,Pn);\
  adjustCurrentItem(this, Sp##Node, ceq);\
  *(PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(PTR_J_ ## Sp ## _ ## Pn)-=geq;\
}\
  (JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (JDVAL_ ## Sp ## _ ## Pn)-=v;
#define _load_dynamic_jacobian1(Sp,Pp,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*pInfo->CKTag[0];\
  double ceq=geq*NP(Pp);\
  adjustCurrentItem(this, Sp##Node, ceq);\
  *(PTR_J_ ## Sp ## _ ## Pp)+=geq;\
}\
(JDVAL_ ## Sp ## _ ## Pp)+=v;

int capinstance::Load(PSpiceDeviceMiscInfo* pInfo, int CKTmode)
     /* actually load the current value into the 
      * sparse matrix previously provided 
      */
{
  register capmodel *model = capmodPtr;
  int ChargeComputationNeeded =  
                 ((CKTmode & (MDAC | MDTRAN | MDINITSMSIG)) ||
                 ((CKTmode & MDBPTR) && (CKTmode & MDUIC)))
                 ? 1 : 0;

{
  JDVAL_p_p=0.0;
  JDVAL_p_n=0.0;
  JDVAL_n_p=0.0;
  JDVAL_n_n=0.0;
}
{
#include "cap.h"
}
  return(0);
}
