###
### Interface: pspice 16.6
 ### created by: admsXml-2.3.0 - Mon, 25 Jul 2016 14:36:59
###########################################################################
## Makefile for PSpice CMI Projects.
## 
##
## Build Info:
## 
## Final product: $(RELATIVE_PATH)\cap.dll
## Product type : dynamic-library
## 
###########################################################################

###########################################################################
## MACROS
###########################################################################

# Macro Descriptions:
# PRODUCT_NAME            Name of the system to build
# MAKEFILE                Name of this makefile
# PERL                    PERL Tool
# GEN_LNK_SCRIPT          Perl script to generate the command file

PRODUCT_NAME              = cap
MAKEFILE                  = pspice_cmi.mk
START_DIR                 = .
ARCH                      = win64
RELATIVE_PATH   = .
#------------------------
# BUILD TOOL COMMANDS
#------------------------

# C++ Compiler: Microsoft Visual C++ Compiler
CPP = cl

# C++ Linker: Microsoft Visual C++ Linker
CPP_LD = link

# Builder: NMAKE Utility
MAKE = nmake


#-------------------------
# Directives/Utilities
#-------------------------

CDEBUG              = -Zi
C_OUTPUT_FLAG       = -Fo
LDDEBUG             = /DEBUG
OUTPUT_FLAG         = -out:
CPPDEBUG            = -Zi
CPP_OUTPUT_FLAG     = -Fo
CPPLDDEBUG          = /DEBUG
STATICLIB_OUTPUT_FLAG = -out:
RM                  = @del
ECHO                = @echo
MV                  = @ren
RUN                 = @cmd /C

#--------------------
# File extensions
#--------------------

H_EXT               = .h
OBJ_EXT             = .obj
C_EXT               = .c
EXE_EXT             = .exe
SHAREDLIB_EXT       = .dll
OBJ_EXT             = .obj
CPP_EXT             = .cpp
MAKE_EXT            = .mk


###########################################################################
## OUTPUT INFO
###########################################################################

PRODUCT = .\cap.dll
PRODUCT_TYPE = "dynamic-library"
BUILD_TYPE = "dynamic Library"

###########################################################################
## INCLUDE PATHS
###########################################################################

INCLUDES = $(START_DIR);$(HIER)\..\include

###########################################################################
## DEFINES
###########################################################################

DEFINES_STANDARD = /D "_WINDLL" /D "_MBCS" 

DEFINES = $(DEFINES_STANDARD) /D "_CRT_SECURE_NO_WARNINGS"

###########################################################################
## OBJECTS
###########################################################################

OBJS = StdAfx.obj analogfunction.obj capacld.obj cap.obj \
    capguesstopology.obj capload.obj capnoise.obj capPSpiceAdapter.obj \
    capsetup.obj captrunc.obj captemp.obj

###########################################################################
## LIBRARIES
###########################################################################

LIBS =  kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib \
    shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib

LDFLAGS =  /NOLOGO /DLL /MANIFEST /OPT:REF /OPT:ICF /LTCG /MACHINE:X64 \
    /NODEFAULTLIB:msvcrt.lib /ERRORREPORT:PROMPT

###########################################################################
## SYSTEM LIBRARIES
###########################################################################

SYSTEM_LIBS = 

#-----------------
# C++ Compiler
#-----------------

CPPFLAGS = $(DEFINES) /O2 /GL /FD /EHsc /MT /W3 /nologo /c /Zi /TP /errorReport:prompt


all : build
	@cmd /C "@echo ### Successfully generated all binary outputs."
	@cmd /C "@echo ### Open the cap.vcxproj file using Microsoft Visual Studio 2013 Community Edition..."


build : set_environment_variables $(PRODUCT)



set_environment_variables : 
    @set INCLUDE=$(INCLUDES);$(INCLUDE)
    @set LIB=$(LIB)


###########################################################################
## FINAL TARGET
###########################################################################

#---------------------------------
# Create a dynamic library         
#---------------------------------

$(PRODUCT): $(OBJS)
    @cmd /C "@echo ### Creating dynamic library "$(PRODUCT)" ..."
    $(CPP_LD) $(LDFLAGS) $(LIBS) /out:cap.dll  $(OBJS)
    @cmd /C "@echo ### Created: $(PRODUCT)"
    $(RM)  $(OBJS)


###########################################################################
## INTERMEDIATE TARGETS
###########################################################################

#---------------------
# SOURCE-TO-OBJECT
#---------------------

.cpp.obj :
    $(CPP) $(CPPFLAGS) -Fo"$@" "$<"


{$(RELATIVE_PATH)}.cpp.obj :
    $(CPP) $(CPPFLAGS) -Fo"$@" "$<"


{$(START_DIR)}.cpp.obj :
    $(CPP) $(CPPFLAGS) -Fo"$@" "$<"


###########################################################################
## DEPENDENCIES
###########################################################################

##$(OBJS) : $(MAKEFILE)


###########################################################################
## MISCELLANEOUS TARGETS
###########################################################################

info : 
    @cmd /C "@echo ### PRODUCT = $(PRODUCT)"
    @cmd /C "@echo ### PRODUCT_TYPE = $(PRODUCT_TYPE)"
    @cmd /C "@echo ### BUILD_TYPE = $(BUILD_TYPE)"
    @cmd /C "@echo ### INCLUDES = $(INCLUDES)"
    @cmd /C "@echo ### DEFINES = $(DEFINES)"
    @cmd /C "@echo ### LIBS = $(LIBS)"
    @cmd /C "@echo ### LDFLAGS = $(LDFLAGS)"
    @cmd /C "@echo ### CPPFLAGS = $(CPPFLAGS)"


clean : 
    $(ECHO) "### Deleting all derived files..."
    @if exist $(PRODUCT) $(RM) $(PRODUCT)
    $(RM) $(OBJS)
    $(ECHO) "### Deleted all derived files."




